//=============================================================================
// MySystems.js
//=============================================================================

/*:
 * @plugindesc My Systems.
 * @author Sasuke KANNAZUKI
 *
 * @help This plugin does not provide plugin commands.
 *
 * When <skill_id:3> is written in a weapon's note field, 
 * skill id # 3 is used for the weapon's attack.
 * If nothing is written, default id(=1) is used.
 *
 * Check Points:
 * - When multiple weapons are equipped, the skill id of the weapon
 *  held in the dominant hand (previously defined) is used.
 * - It is most favorable for "skill type" to be "none"(=0),
 *  otherwise you cannot attack when your skill is blocked.
 *
 * Usage examples of this plugin:
 * - to create all-range weapons
 * - to create dual-attack or triple-attack weapons
 * - If healing skill is set when actor attacks, you can choose a friend to heal.
 * - It is possible to make a weapon that functions similar to a guard command. 
 */

/*:ja
 * @plugindesc Elementy mojej gry
 * @author Wole pozostac anonimowy
 *
 * @help
 *
 */



function sprawdzPoleWidzenia(zdarzenie, pole){
	if($gameMap.event(zdarzenie).direction() == 2){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) <= pole)&& ($gameMap.event(zdarzenie).y <= $gamePlayer.y);
	}
	else if($gameMap.event(zdarzenie).direction() == 4){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) <= pole) && ($gameMap.event(zdarzenie).x >= $gamePlayer.x);
	}
	else if($gameMap.event(zdarzenie).direction() == 6){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) <= pole) && ($gameMap.event(zdarzenie).x <= $gamePlayer.x);
	}
	else if($gameMap.event(zdarzenie).direction() == 8){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) <= pole) && ($gameMap.event(zdarzenie).y >= $gamePlayer.y);
	}
	else{
		return false
	}
}

function sprawdzRegion(zdarzenie){
	return $gamePlayer.regionId() == $gameMap.regionId($gameMap.event(zdarzenie).x, $gameMap.event(zdarzenie).y);
}

function sprawdzRegionGracza(region){
	return $gamePlayer.regionId() == region;
}

function sprawdzZasiegAtakuWroga(zdarzenie){
	if($gameMap.event(zdarzenie).direction() == 2){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1)&& ($gameMap.event(zdarzenie).y < $gamePlayer.y);
	}
	else if($gameMap.event(zdarzenie).direction() == 4){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).x > $gamePlayer.x);
	}
	else if($gameMap.event(zdarzenie).direction() == 6){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).x < $gamePlayer.x);
	}
	else if($gameMap.event(zdarzenie).direction() == 8){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).y > $gamePlayer.y);
	}
	else{
		return false
	}
}

function sprawdzZasiegAtakuGracza(zdarzenie){
	if($gamePlayer.direction() == 2){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).y > $gamePlayer.y);
	}
	else if($gamePlayer.direction() == 4){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).x < $gamePlayer.x);
	}
	else if($gamePlayer.direction() == 6){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).x > $gamePlayer.x);
	}
	else if($gamePlayer.direction() == 8){
		return (Math.abs($gameMap.event(zdarzenie).y - $gamePlayer.y) + Math.abs($gameMap.event(zdarzenie).x - $gamePlayer.x) == 1) && ($gameMap.event(zdarzenie).y < $gamePlayer.y);
	}
	else{
		return false
	}
}

function sprawdzCicheZabojstwo(zdarzenie){
	if($gamePlayer.direction() == 2){
		return $gameMap.event(zdarzenie).direction() == 2;
	}
	else if($gamePlayer.direction() == 4){
		return $gameMap.event(zdarzenie).direction() == 4;
	}
	else if($gamePlayer.direction() == 6){
		return $gameMap.event(zdarzenie).direction() == 6;
	}
	else if($gamePlayer.direction() == 8){
		return $gameMap.event(zdarzenie).direction() == 8;
	}
	else{
		return false
	}
}

function sprawdzWspolrzedne(zdarzenie){
	return $gameMap.event(zdarzenie).x == $gamePlayer.x && $gameMap.event(zdarzenie).y == $gamePlayer.y;
}

function sprawdzTeren(id){
	return $gameMap.terrainTag($gamePlayer.x, $gamePlayer.y) == id;
}

function sprawdzImieBohatera(id, napis){
	return $gameActors.actor(id).name().toLowerCase() == napis;
}